// CommandLineParser.h

#pragma once

class CCommandLineParser
{
public:
	CCommandLineParser(LPCTSTR lpstrCmdLine)
	{
		m_command = new TCHAR[lstrlen(lpstrCmdLine)+1];
		lstrcpy(m_command, lpstrCmdLine);
		m_next = &m_command[0];
	}
	~CCommandLineParser()
	{
		delete[] m_command;
	}
	LPCTSTR GetNextParam()
	{
		const TCHAR QUOTE = '\"';
		LPCTSTR		DELIM = " \t\0";	// Space, Tab, Null

		if(m_next == NULL)
			return NULL;
		LPCTSTR start = m_next + _tcsspn(m_next, DELIM);
		switch(*start)
		{
		case '\0':
			return NULL;
		case QUOTE:	// quoteň͂܂Ă
			start++;
			m_next = _tcschr(start+1, QUOTE);
			break;
		default:	// quoteň͂܂ĂȂ
			m_next = _tcspbrk(start, DELIM);
			break;
		}
		if(m_next)
			*m_next++ = '\0';
		return start;
	}
private:
	LPTSTR	m_command;
	LPTSTR	m_next;
};
