// OpenLink.cpp

#include "stdafx.h"
#include <SHLOBJ.h>

CAppModule _Module;

#include "CommandLineParser.h"

bool OpenLink(LPCTSTR shortcut)
{
	HRESULT 	hr;
	//::MessageBox(NULL, shortcut, "ShortCut", MB_OK);

	// IuWFNg̍쐬
	CComPtr<IShellLink>	link;
	hr = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (void**)&link);
	if(FAILED(hr))	return false;
	CComPtr<IPersistFile> persist;
	hr = link->QueryInterface(IID_IPersistFile, (void**)&persist);
	if(FAILED(hr))	return false;

	// V[gJbgǂݍ
	WCHAR wShortcut[MAX_PATH];
	MultiByteToWideChar(CP_ACP, 0, shortcut, -1, wShortcut, MAX_PATH);
	hr = persist->Load(wShortcut, STGM_READ);
	if(FAILED(hr))	return false;

	// ÑpX𓾂
	TCHAR destname[MAX_PATH];
	WIN32_FIND_DATA finddata;
	hr = link->GetPath(destname, MAX_PATH, &finddata, SLGP_UNCPRIORITY);
	if(FAILED(hr))	return false;

	// etH_𓾂Bp̊֐̂ȁH
	*_tcsrchr(destname, '\\') = '\0';

	// tH_open
	//::MessageBox(NULL, destname, NULL, MB_OK);
	ShellExecute(NULL, "open", destname, NULL, NULL, SW_SHOWNORMAL);
	return 0;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
	ATLASSERT(SUCCEEDED(hRes));

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	//::MessageBox(NULL, lpstrCmdLine, "CommandLine", MB_OK);
	CCommandLineParser parser(lpstrCmdLine);
	LPCTSTR file;
	while((file = parser.GetNextParam()) != NULL)
	{
		OpenLink(file);
	}

	_Module.Term();
	::CoUninitialize();

	return 0;
}
